{% extends 'inventory/base.html' %}
{% load humanize %}

{% block title %} | Inventory {% endblock %}

{% block content %}
    <div class="container">
        <h1 class="m-3 text-center">Orders</h1>
        <h4>Orders in progress</h4>
        <div class="list-group">
            {% for order, timestamp, part_orders in in_progress_orders %}
                <div class="d-flex flex-column list-group-item">
                    <div class="d-flex flex-row align-items-center justify-content-between">
                        <div class="d-flex flex-column flex-grow-1">
                            <h5 class="mb-1">#{{ order.id }} | {{ order.user.first_name }} {{ order.user.last_name }}</h5>
                            <span>{{ order.status_label }} on {{ timestamp | date }}</span>
                        </div>
                        <a class="btn btn-primary" href="{% url 'fill_order' order_id=order.id %}">Fill Order</a>
                        <button class="btn btn-info ml-3" type="button" data-toggle="collapse"
                                data-target="#collapse{{ order.id }}" aria-expanded="false"
                                aria-controls="collapse{{ order.id }}">
                            Details
                        </button>
                    </div>
                    <div class="collapse" id="collapse{{ order.id }}">
                       {% include 'inventory/part_order_details.html' with part_orders=part_orders%}
                    </div>
                </div>
            {% empty %}
                <p class="text-center">There are no unfilled orders</p>
            {% endfor %}
        </div>

        {% if perms.inventory.fill_requests %}
            <h4 class="mt-3">Requests in progress</h4>
            {% for request in unfilled_requests %}
                <div class="card mt-3">
                    <div class="card-header d-flex flex-row align-items-center justify-content-between">
                        <h5 class="card-title m-0">#{{ request.id }} | {{ request.user.first_name }} {{ request.user.last_name }}</h5>
                        <div class="btn-toolbar">
                            <button
                                    class="btn btn-success"
                                    type="button" data-toggle="modal"
                                    data-target="#complete_request_{{ request.id }}"
                            >
                                <i class="fas fa-check"></i>
                            </button>
                            <button
                                    class="btn btn-danger ml-3"
                                    type="button" data-toggle="modal"
                                    data-target="#reject_request_{{ request.id }}"
                            >
                                <i class="fas fa-times"></i>
                            </button>
                        </div>
                    </div>
                    <div class="card-body">
                        {{ request.request }}
                    </div>
                </div>
                <div class="modal" id="complete_request_{{ request.id }}" tabindex="-1" role="dialog">
                    <div class="modal-dialog modal-lg" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">Complete Request</h5>
                                <button type="button" class="close" data-dismiss="modal">
                                    <i class="fas fa-times"></i>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form onsubmit="submit_form(event)">
                                    {% csrf_token %}
                                    <input type="hidden" name="action" value="complete_request">
                                    <input type="hidden" name="request" value="{{ request.id }}">
                                    <label for="notes">Notes</label>
                                    <textarea type="text" class="form-control mb-3" name="notes"></textarea>
                                    <button type="submit" class="btn btn-success">Complete</button>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal" id="reject_request_{{ request.id }}" tabindex="-1" role="dialog">
                    <div class="modal-dialog modal-lg" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">Reject Request</h5>
                                <button type="button" class="close" data-dismiss="modal">
                                    <i class="fas fa-times"></i>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form onsubmit="submit_form(event)">
                                    {% csrf_token %}
                                    <input type="hidden" name="action" value="reject_request">
                                    <input type="hidden" name="request" value="{{ request.id }}">
                                    <label for="notes">Notes</label>
                                    <textarea type="text" class="form-control mb-3" name="notes"></textarea>
                                    <button type="submit" class="btn btn-danger">Reject</button>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                {% empty %}
                <p class="text-center">There are no unfilled requests</p>
            {% endfor %}
        {% endif %}

        <h4 class="mt-3">Filled orders</h4>
        {% if orders_pages.num_pages > 1 %}
            <div class="pagination mb-3">
                {% if orders_page.has_previous %}
                    <div class="page-item"><a class="page-link" href="?page={{ orders_page.previous_page_number }}"><i class="fas fa-arrow-left"></i></a></div>
                {% endif %}
                {% for page_number in orders_pages.page_range %}
                    {% if page_number == orders_page.number %}
                        <div class="page-item active"><a class="page-link" href="?page={{ page_number }}">{{ page_number }}</a></div>
                    {% else %}
                        <div class="page-item"><a class="page-link disabled" href="?page={{ page_number }}">{{ page_number }}</a></div>
                    {% endif %}
                {% endfor %}
                {% if orders_page.has_next %}
                    <div class="page-item"><a class="page-link" href="?page={{ orders_page.next_page_number }}"><i class="fas fa-arrow-right"></i></a></div>
                {% endif %}
            </div>
        {% endif %}
        <div class="list-group">
            {% for order, timestamp, part_orders in orders_page %}
                <div class="d-flex flex-column list-group-item {% if order.status == 'COMPLETE' %} border-warning {% elif order.status == 'PICKED_UP' %} border-success {% endif %}">
                    <div class="d-flex flex-row align-items-center justify-content-between">
                        <div class="d-flex flex-column flex-grow-1">
                            <h5 class="mb-1">#{{ order.id }} | {{ order.user.first_name }} {{ order.user.last_name }}</h5>
                            <span>{{ order.status_label }} on {{ timestamp | date }}</span>
                        </div>
                        {% if order.status != "PICKED_UP" %}
                            <form onsubmit="submit_form(event)">
                                {% csrf_token %}
                                <input type="hidden" name="action" value="picked_up">
                                <input type="hidden" name="order" value="{{ order.id }}">
                                <button class="btn btn-secondary ml-3" type="submit">Picked Up</button>
                            </form>
                        {% endif %}
                        <button class="btn btn-info ml-3" type="button" data-toggle="collapse"
                                data-target="#collapse{{ order.id }}" aria-expanded="false"
                                aria-controls="collapse{{ order.id }}">
                            Details
                        </button>
                    </div>
                    <div class="collapse" id="collapse{{ order.id }}">
                        {% include 'inventory/part_order_details.html' with part_orders=part_orders%}
                    </div>
                </div>
            {% empty %}
                <p class="text-center">No filled orders</p>
            {% endfor %}
        </div>

        {% if perms.inventory.fill_requests %}
            <h4 class="mt-3">Filled requests</h4>
            {% for request in filled_requests %}
                <div class="card mt-3">
                    <div class="card-header d-flex flex-row align-items-center justify-content-between {% if request.status == 'COMPLETE' %} bg-success {% elif request.status == 'REJECTED' %} bg-danger {% endif %}">
                        <h5 class="card-title m-0">#{{ request.id }} | {{ request.user.first_name }} {{ request.user.last_name }}</h5>
                        <span>{{ request.status_label }}</span>
                    </div>
                    <div class="list-group list-group-flush">
                        <div class="list-group-item">
                            {{ request.request }}
                        </div>
                        {% if request.notes != None and request.notes|length > 0 %}
                            <div class="list-group-item">
                                {{ request.notes }}
                            </div>
                        {% endif %}
                    </div>
                </div>
            {% empty %}
                <p class="text-center">There are no filled requests</p>
            {% endfor %}
        {% endif %}
    </div>
{% endblock %}
